<template>
    <div class="board relative bg-white mr-2 p-2 float-left w-full h-full flex flex-col">
        <div class="heading font-bold text-gray-800 bg-gray-100 h-8 border-b -mt-2 -ml-2 -mr-2 rounded-t-lg pl-2 pt-1">
            <div class="title relative float-left text-pink-500">
                <div class="h-4 w-4 m-auto cursor-pointer inline-block">
                    <img svg-inline class="fill-current inline-block" src="./pix/zond/plugin.svg" />
                </div>
                <span v-if="!loaded">
                    Add a New Report
                </span>
                <span v-if="loaded">
                    Update #{{report.id}}
                </span>
            </div>
            <div class="submit relative float-right">
                <button v-if="!loaded" class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="submitReport()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/add-solid.svg" />
                    <span>Add</span>
                </button>
                <button v-if="loaded" class="text-teal-500 hover:text-teal-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="updateReport()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/edit-pencil.svg" />
                    <span>Update</span>
                </button>
                <button class="text-red-500 hover:text-red-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="removeReport()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/trash.svg" />
                    <span>Delete</span>
                </button>
                <button class="text-red-500 hover:text-red-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="discard()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/close-solid.svg" />
                    <span>Cancel</span>
                </button>
            </div>
        </div>
        <div class="body flex flex-row items-stretch content-center w-full h-full">
            <div class="meta flex flex-col mt-2 float-left mr-1 flex-grow">
                <div class="input flex flex-col items-left mb-1 bg-gray-200 py-1 px-2 text-sm h-32">
                    <label class="mb-1 text-gray-700 font-semibold">Area of Interest (AoI)</label>
                    <textarea v-model="reportAoI" class="w-full bg-gray-100 h-8 border border-gray-400 rounded-md px-2 h-full mb-1"></textarea>
                </div>
                <div class="input flex flex-col items-left mb-1 bg-gray-200 py-1 px-2 text-sm">
                    <label class="mb-1 text-gray-700 font-semibold">Type of Report</label>
                    <v-select v-model="reportType" label="label" :options="types" :reduce="type => type.id" class="w-full bg-gray-100"></v-select>
                </div>
                <div class="input flex flex-col items-left mb-1 bg-gray-200 py-1 px-2 text-sm">
                    <label class="mb-1 text-gray-700 font-semibold">Time of Interest (ToI)</label>
                    <v-date-picker mode="single" v-model="reportToI" class="w-full relative" :popover="{visibility: 'click' }"></v-date-picker>
                </div>
            </div>
            <div class="meta flex flex-col mt-2 ml-2 float-left border-l flex-grow relative">
                <wee-spatial-property-editor ref="properties" :universe="universe" :common="common" :dictionary="dictionary"></wee-spatial-property-editor>
            </div>
        </div>
        <div v-if="modal" class="absolute left-0 top-0 bg-white opacity-75 w-full h-full flex flex-col">
            <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center absolute right-0 top-0 mr-2 mt-2" v-on:click="resetModal()">
                <img svg-inline class="fill-current inline-block w-8 h-8" src="./pix/zond/close-outline.svg" />
            </button>
            
            <div v-if="message" class="w-full m-auto text-center">{{message}}</div>
            <div v-if="adding" class="w-full m-auto text-center">
                <img src="./pix/infinity.gif" class="block relative m-auto" />
                Adding New Report ... 
            </div>
            <div v-if="added" class="w-full m-auto text-center">
                <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-up.svg" />
                Added New Report {{added}}
            </div>
            <div v-if="updating" class="w-full m-auto text-center">
                <img src="./pix/infinity.gif" class="block relative m-auto" />
                Updating Report {{report.id}}
            </div>
            <div v-if="updated" class="w-full m-auto text-center">
                <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-teal-600" src="./pix/zond/thumbs-up.svg" />
                Updated Report {{report.id}}
            </div>
            <div v-if="removing" class="w-full m-auto text-center">
                <img v-if="removing == 2" src="./pix/infinity.gif" class="block relative m-auto" />
                <span v-if="removing == 2">Removeing Report {{report.id}}</span>
                <span v-if="removing != 2">Remove Report {{report.id}}</span>
                <button v-if="removing != 2" class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="removeReport(true)">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/trash.svg" />
                    <span>Remove</span>
                </button>
            </div>
        </div>
    </div>
</template>
<script>
    import Vue from 'vue'
    import vSelect from 'vue-select'
    import axios from 'axios'
    import axiosCancel from 'axios-cancel';
    import VCalendar from 'v-calendar';
    import WeeSpatialPropertyEditor from './WeeSpatialPropertyEditor';
    
    const DB_WB_DISTRICTS =  [{"value":"AD","label":"Alipurduar"},{"value":"BN","label":"Bankura"},{"value":"BR","label":"Paschim Bardhaman"},{"value":"BR","label":"Purba Bardhaman"},{"value":"BI","label":"Birbhum"},{"value":"KB","label":"Cooch Behar"},{"value":"DA","label":"Darjeeling"},{"value":"UD","label":"Uttar Dinajpur"},{"value":"DD","label":"Dakshin Dinajpur"},{"value":"HG","label":"Hooghly"},{"value":"HR","label":"Howrah"},{"value":"JP","label":"Jalpaiguri"},{"value":"JH","label":"Jhargram"},{"value":"KO","label":"Kolkata"},{"value":"KA","label":"Kalimpong"},{"value":"MA","label":"Malda"},{"value":"ME","label":"Paschim Medinipur"},{"value":"ME","label":"Purba Medinipur"},{"value":"MU","label":"Murshidabad"},{"value":"NA","label":"Nadia"},{"value":"PN","label":"North 24 Parganas"},{"value":"PS","label":"South 24 Parganas"},{"value":"PU","label":"Purulia"}];;
    
    Vue.component('v-select', vSelect);
    Vue.use(VCalendar);

    axiosCancel(axios, {
        debug: false // default
    });
       
    export default {
        name: "WeeSpatialReportEditor",
        props: {
            project: {
                type: Number,
                required: true
            },
            report: {
                type: Object,
                default: null
            },
            cancel: {
                type: Function,
                default: function(){}
            },
            universe: {
                type: Array,
                default: []
            },
            common: {
                type: Array,
                default: []
            }
        },
        components: {
            WeeSpatialPropertyEditor
        },
        data: function(){
            return {
                loaded: false,
                districts: DB_WB_DISTRICTS,
                types: synopsis.types,
                modal:  false,
                adding: false,
                added: false,
                updating: false,
                updated:  false,
                removing: false,
                message: null,
                reportAoI: '',
                reportToI: '',
                reportType: synopsis.types.length ? synopsis.types[0].id : '',
                universe: ['country','city','district','ward','locality','contact','pincode','organization','social','link'],
                dictionary: {}
            }
        },
        created(){
            console.log("created", this.report);
            if(this.report){
                this.loaded = true;
                this.load(this.report);
            }
        },
        watch: {
            report(n, o){
                console.log('WeeSpatialReportEditor::watch::report', n, o);
                if(n){
                    this.loaded = true;
                    this.load(n);
                }else{
                    this.loaded = false;
                }
            }
        },
        methods: {
            discard(){
                this.cancel();
                this.clear();
                this.loaded = false;
            },
            load(r){
                console.log('WeeSpatialReportEditor::load', r);
                console.log(new Date(r.toi));
                this.reportAoI = r.aoi;
                this.reportToI = new Date(r.toi);
                this.reportType = r.type.id;
                this.dictionary = r.properties;
            },
            clear(){
                this.reportAoI = '';
                this.reportToI = '';
                this.reportType = '';
                this.dictionary = {};
            },
            summarize(){
                return {
                    aoi:   this.reportAoI,
                    toi:   this.reportToI,
                    type:  this.reportType,
                    story: this.reportAoI,
                    properties: this.$refs.properties.values()
                };
            },
            submitReport(){
                let self = this;
                this.resetModal();
                this.modal  = true;
                this.adding = true;
                let errorf = function(message){
                    self.adding = false;
                    self.message = message;
                    setTimeout(function(){
                        self.resetModal();
                        self.discard();
                    }, 1000);
                }
                axios.post(this.createUrl, this.summarize()).then(function(response){
                    if(response.data.success){
                        self.adding = false;
                        self.added  = response.data.id;
                        setTimeout(function(){
                            self.resetModal();
                            self.$emit('added', response.data.id);
                        }, 2000);
                        console.log(response.data);
                    }else{
                        errorf(response.data.message);
                        // TODO Failed to save report
                    }
                }).catch(function(error){
                    console.log(error);
                });
            },
            updateReport(){
                let self = this;
                this.resetModal();
                this.modal    = true;
                this.updating = true;
                let errorf = function(message){
                    self.updating = false;
                    self.message  = message;
                    setTimeout(function(){
                        self.resetModal();
                    }, 1000);
                }
                axios.post(this.updateUrl, this.summarize()).then(function(response){
                    if(response.data.success){
                        self.updating  = false; 
                        self.updated   = true;
                        setTimeout(function(){
                            self.resetModal();
                            self.discard();
                            self.$emit('updated', response.data.id);
                        }, 2000);
                        self.loaded = false;
                    }else{
                        errorf(response.data.message);
                        // TODO Failed to save report
                    }
                }).catch(function(error){
                    console.log(error);
                });
            },
            removeReport(confirm){
                if(!confirm){
                    this.modal = true;
                    this.removing = true;
                }else{
                    let self = this;
                    this.removing = 2;
                    let errorf = function(message){
                        self.removing = false;
                        self.message = message;
                        setTimeout(function(){
                            self.resetModal();
                        }, 1000);
                    }
                    axios.post(this.removeUrl, this.summarize()).then(function(response){
                        if(response.data.success){
                            self.removing = false;
                            setTimeout(function(){
                                self.resetModal();
                                self.$emit('removed', response.data.id);
                            }, 2000);
                            console.log(response.data);
                        }else{
                            errorf(response.data.message);
                            // TODO Failed to save report
                        }
                    }).catch(function(error){
                        console.log(error);
                    });
                }
            },
            resetModal(){
                this.adding    = false;
                this.added     = false;
                this.updating  = false;
                this.updated   = false;
                this.removing  = false;
                this.removed   = false;
                this.modal     = false;
            }
        },
        computed: {
            createUrl(){
                return this.project ? ('/reports/'+this.project+'/create') : null;
            },
            updateUrl(){
                return this.report ? ('/reports/update/'+this.report.id) : null;
            },
            removeUrl(){
                return this.report ? ('/reports/remove/'+this.report.id) : null;
            }
        }
    }
</script>
<style>

</style>
